//
// $Header: E:/TNG/src/rcs/celworld.h 1.2 1997/02/22 14:38:52 dbm Exp $
//

#ifndef CELWORLD_H
#define CELWORLD_H
 
#include "world.h"
 
/////////////////////////////////////////////////////////////////////////////
//
//	bioCellWorld
//
   
class bioCellWorld : public bioWorld
{ 
  public:
  	ctor				bioCellWorld (void);
  	dtor				~bioCellWorld (void);
                            
  	virtual void		SetSize (int);
#if 0 // MFC only
	virtual void		ReadMap (char*);
#endif
  	virtual void		CreateThing (char id, int x, int y) {} 
  	
	override void		AddThing (bioThing*, double x, double y);
	override void		RemoveThing (bioThing*);
	override void		PlaceRandom (bioThing*);
	  	                        
  	override bioObject*	WhatsAt (double x, double y, bioThing*); 
  	                                           
  	override void		Resize (int width, int height);
  	override void		UserSelect (int x, int y);
  	override void		UserEdit (int x, int y);
  	
  protected:
  	int					_size;		// how many cells across 
  	int					_width;		// how many pixels across one cell
  	int					_side; 		// how many pixels across the world
  	int					_winWidth;	// window width
  	int					_winHeight;	// window height
  	int					_offX;		// horizontal offset
  	int					_offY;		// vertical offset
  	bioThing***			_cells;		// discrete regions of the world	
};

#endif // CELWORLD_H
