//
// $Header: E:/TNG/src/rcs/fsm.h 1.2 1997/02/22 14:38:54 dbm Exp $
//
  
#ifndef FSM_H
#define FSM_H

#include "program.h"

/////////////////////////////////////////////////////////////////////////////
//
//	bioFSM (finite state machine program)
//
  
class bioFSM : public bioProgram
{
  public:
    ctor				bioFSM (int, int, int);
    dtor				~bioFSM (void);
    
    override void		Init (void);
	override void		Randomize (void);
  	override int		Think (int* inputVector, int size);
  	override void		ReadArray (int* array, int size);
	override void		SetState (bioBitVector&);
	override void		GetState (bioBitVector&);
  
  protected: 
    int           		_state;
    int                 _stateSize;
    int                 _stateMask;
    int                 _inputSize;
    int                 _inputMask;
    int                 _output;
    int                 _outputSize;
    int                 _outputMask;
    int*                _table;
    int                 _tableSize;
    int                 _index;
};

#endif // FSM_H
