//
// Header file for populat.cpp
// Last Revised: 28 November 1997
//
// $Header: E:/TNG/src/rcs/populat.h 1.2 1997/02/22 14:39:00 dbm Exp $
//

#ifndef POPULAT_H
#define POPULAT_H

#include "simbio.h"
#include "gtype.h"
#include "ptype.h"

/////////////////////////////////////////////////////////////////////////////
//
//     bioPopulation
//
     
class bioPopulation : public bioObject
{
  public:
     ctor               bioPopulation (void);
     dtor               ~bioPopulation (void);

     virtual void       SortByFitness (void);
     virtual void       Breed (void);
	 virtual void		Socialize(void);	// like Breed() but does not destroy phenotypes

     virtual void       SetSize (int);
     virtual int        GetSize (void);

     virtual void       SetElite (int);
     virtual int        GetElite (void);

     virtual void       SetMutationRate (double);
     virtual double     GetMutationRate (void);

     virtual bioGType*  GenGType (void) = 0;
     virtual bioPType*  GenPType (bioGType*) = 0;

     virtual bioPType*  GetPType (int idx);

     virtual double     GetMaxFitness (void);
     virtual double     GetMinFitness (void);
     virtual double     GetAvgFitness (void);

  protected:
     bioGType*          _ChooseParent (void);

     int                _size;
     int                _elite;
     int                _sorted;

     bioPType**         _ptypes;

     double             _mutationRate;
     double             _totalFitness;
     double             _maxFitness;
     double             _minFitness;
     double             _avgFitness;
};

#endif // POPULAT_H
