//
// $Header: E:/TNG/src/rcs/world.h 1.2 1997/02/22 14:39:14 dbm Exp $
//
 
#ifndef WORLD_H
#define WORLD_H

#include "simbio.h"
#include "thing.h" 
#include "list.h"
 
/////////////////////////////////////////////////////////////////////////////
//
//	bioWorld
//
                                   
class bioDC;
                                   
class bioWorld : public bioObject
{
  public:
  	ctor				bioWorld (void);
  	dtor				~bioWorld (void);
  	                   
	virtual void		Init (void) {}
	  	                   
	virtual void		AddThing (bioThing*, double x, double y);
	virtual void		RemoveThing (bioThing*); 
	virtual void		DeleteThing (bioThing*); 
	virtual int			ThingCount (void);
	
  	virtual void		NextStep (void);
	virtual void		ResolveAction (bioThing*, int intent) = 0;

	virtual void		PlaceRandom (bioThing*) = 0;
	virtual void		MoveThing (bioThing*, double x, double y, int relative = 0);
	virtual void		TurnThing (bioThing*, double angle, int relative = 0);
	
	virtual bioObject*	WhatsAt (double x, double y, bioThing*) = 0;
	virtual void		XformPos (double x, double y, bioThing*, double& nx, double& ny);
 	   
  	virtual void		Redraw (bioDC*) = 0;
  	virtual void		Resize (int width, int height) = 0;
  	
  	virtual void		UserSelect (int x, int y) {}
  	virtual void		UserEdit (int x, int y)  {} 
  	              
  protected:
	void				_SetPosition (bioThing*, double x, double y); 
	void				_ExecuteThings (void);
	
	bioList				_things;
	bioList				_deathRow;
};

#endif // WORLD_H

