//
// $Header: E:/TNG/src/rcs/xmatrix.h 1.2 1997/02/22 14:39:14 dbm Exp $
//
 
#ifndef XMATRIX_H
#define XMATRIX_H

#include <iostream.h>
#include <iomanip.h>
#include <math.h> 

#include "simbio.h"

#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif
           
#ifndef DEGREES           
#define DEGREES(x) (x * M_PI / 180.0)
#endif
           
class Point
{
public:
	Point();
	Point (int, int);
	
	int				x;
	int				y;
};
                        
class XMatrix
{
public:
	XMatrix();
	
	double&			operator()(int, int);
	const double&		operator()(int, int) const;
	            
	void			Clear();
	void			Identity();
		            
	void			Translate (double x, double y);
	void			Scale (double sx, double sy);
	void			Rotate (double theta);
	void			RotateAboutPoint (double theta, double x, double y);
	
protected:
	double			_val[3][3];
};

Point				operator* (Point& p, XMatrix& m);
XMatrix				operator* (XMatrix& m1, XMatrix& m2);

ostream&			operator<< (ostream&, const Point&); 
ostream&			operator<< (ostream&, const XMatrix&); 
    
#endif // XMATRIX_H    
