// Simulation.h : Declaration of the CSimulation

#ifndef __SIMULATION_H_
#define __SIMULATION_H_

#include "resource.h"       // main symbols
#include "tngcomCP.h"

class tngSimulation2 : public tngSimulation
{
public:
	ctor			tngSimulation2();

	virtual void    SetGMax (int val)					{ _gmax = val; }
	virtual int		GetGMax()							{ return _gmax; }

	virtual void	SetIMax (int val)					{ _imax = val; }
	virtual int		GetIMax()							{ return _imax; }

	virtual void	SetPrintIt (int val)				{_printIt = val; }
	virtual int		GetPrintIt()						{ return _printIt; }

	virtual void	SetPrintGen (int val)				{_printGen = val; }
	virtual int		GetPrintGen()						{ return _printGen; }
	
	virtual void	SetRandomSeed (int val)				{ _seed = val; }
	virtual int		GetRandomSeed()						{ return _seed; }

	virtual void	SetMutationRate (float val)			{ _mrate = val; }
	virtual float	GetMutationRate()					{ return _mrate; }

	virtual void	SetFsmStates (int val)				{ _fsmStates = val; }
	virtual int		GetFsmStates()						{ return _fsmStates; }

	virtual void	SetFsmMemory (int val)				{ _fsmMemory = val; }
	virtual int		GetFsmMemory()						{ return _fsmMemory; }
	
	virtual void	SetPureBuyerCount (int val)			{ _pureBuyerCount = val; }
	virtual int		GetPureBuyerCount()					{ return _pureBuyerCount; }

	virtual void	SetPureSellerCount (int val)		{ _pureSellerCount = val; }
	virtual int		GetPureSellerCount()				{ return _pureSellerCount; }

	virtual void	SetBuysellCount (int val)			{ _buysellCount = val; }
	virtual int		GetBuysellCount()					{ return _buysellCount; }

	virtual void    SetBuyerQuota (int val)				{ _buyerQuota = val; }
	virtual int		GetBuyerQuota()						{ return _buyerQuota; }

	virtual void    SetSellerQuota (int val)			{ _sellerQuota = val; }
	virtual int		GetSellerQuota()					{ return _sellerQuota; }
	
	virtual void    SetInitExpPayoff (float val)		{ _initExpPayoff = val; }
	virtual float	GetInitExpPayoff()					{ return _initExpPayoff; }

	virtual void    SetRefusalPayoff (float val)		{ _refusalPayoff = val; }
	virtual float	GetRefusalPayoff()					{ return _refusalPayoff; }

	virtual void    SetInactivePayoff (float val)		{ _inactivePayoff = val; }
	virtual float	GetInactivePayoff()					{ return _inactivePayoff; }

	virtual void    SetCoopPayoff (float val)			{ _bothCoop = val; }
	virtual float   GetCoopPayoff()						{ return _bothCoop; }

	virtual void    SetDefectPayoff (float val)			{ _bothDefect = val; }
	virtual float   GetDefectPayoff()					{ return _bothDefect; }

	virtual void    SetTemptationPayoff (float val)		{ _temptation = val; }
	virtual float   GetTemptationPayoff()				{ return _temptation; }

	virtual void    SetSuckerPayoff (float val)			{ _sucker = val; }
	virtual float   GetSuckerPayoff()					{ return _sucker; }

	virtual void	SetElitePercentPB (float val)		{ _elitePercentPB = val; }
	virtual float	GetElitePercentPB()					{ return _elitePercentPB; }

	virtual void	SetElitePercentPS (float val)		{ _elitePercentPS = val; }
	virtual float	GetElitePercentPS()					{ return _elitePercentPS; }

	virtual void	SetElitePercentBS (float val)		{ _elitePercentBS = val; }
	virtual float	GetElitePercentBS()					{ return _elitePercentBS; }

	virtual void	SetExperienceGain (float val)		{ _experienceGain = val; }
	virtual float	GetExperienceGain()					{ return _experienceGain; }

	virtual IScores*		GetScores(tngPOPULATION);
	virtual IPopulation*	GetPopulation(tngPOPULATION);

};

/////////////////////////////////////////////////////////////////////////////
// CSimulation
class ATL_NO_VTABLE CSimulation : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CSimulation, &CLSID_Simulation>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CSimulation>,
	public IDispatchImpl<ISimulation, &IID_ISimulation, &LIBID_TNGCOMLib>,
	public CProxy_ISimulationEvents< CSimulation >
{
public:
	CSimulation();
	~CSimulation();

DECLARE_REGISTRY_RESOURCEID(IDR_SIMULATION)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CSimulation)
	COM_INTERFACE_ENTRY(ISimulation)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()
BEGIN_CONNECTION_POINT_MAP(CSimulation)
CONNECTION_POINT_ENTRY(DIID__ISimulationEvents)
END_CONNECTION_POINT_MAP()


// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// ISimulation
public:
	STDMETHOD(get_ExperienceGain)(/*[out, retval]*/ float *pVal);
	STDMETHOD(put_ExperienceGain)(/*[in]*/ float newVal);
	STDMETHOD(get_PrintGen)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_PrintGen)(/*[in]*/ short newVal);
	STDMETHOD(get_PrintIt)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_PrintIt)(/*[in]*/ short newVal);
	STDMETHOD(SaveFile)(/*[in]*/ BSTR inifile);
	STDMETHOD(OpenFile)(/*[in]*/ BSTR inifile);
	STDMETHOD(Stop)();
	STDMETHOD(Resume)();
	STDMETHOD(Pause)();
	STDMETHOD(get_SellerQuota)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_SellerQuota)(/*[in]*/ short newVal);
	STDMETHOD(get_BuyerQuota)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_BuyerQuota)(/*[in]*/ short newVal);
	STDMETHOD(get_ElitePercent)(tngPOPULATION ePop, /*[out, retval]*/ float *pVal);
	STDMETHOD(put_ElitePercent)(tngPOPULATION ePop, /*[in]*/ float newVal);
	STDMETHOD(get_Payoff)(tngPAYOFF ePayoff, /*[out, retval]*/ float *pVal);
	STDMETHOD(put_Payoff)(tngPAYOFF ePayoff, /*[in]*/ float newVal);
	STDMETHOD(get_BuysellCount)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_BuysellCount)(/*[in]*/ short newVal);
	STDMETHOD(get_PureSellerCount)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_PureSellerCount)(/*[in]*/ short newVal);
	STDMETHOD(get_PureBuyerCount)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_PureBuyerCount)(/*[in]*/ short newVal);
	STDMETHOD(GetPopulation)(/*[in]*/ tngPOPULATION ePop, /*[out, retval]*/ IPopulation**);
	STDMETHOD(GetScores)(/*[in]*/ tngPOPULATION, /*[out, retval]*/ IScores**);
	STDMETHOD(Go)();
	STDMETHOD(Run)();
	STDMETHOD(get_FsmMemory)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_FsmMemory)(/*[in]*/ short newVal);
	STDMETHOD(get_FsmStates)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_FsmStates)(/*[in]*/ short newVal);
	STDMETHOD(get_MutationRate)(/*[out, retval]*/ float *pVal);
	STDMETHOD(put_MutationRate)(/*[in]*/ float newVal);
	STDMETHOD(get_RandomSeed)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_RandomSeed)(/*[in]*/ short newVal);
	STDMETHOD(get_IMax)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_IMax)(/*[in]*/ short newVal);
	STDMETHOD(get_GMax)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_GMax)(/*[in]*/ short newVal);

protected:
	void				_Run();

	tngSimulation2		_sim;
	int					_nGen;
	bool				_bPaused;
	bool				_bStopped;
};

#endif //__SIMULATION_H_
