// TradeBot.cpp : Implementation of CTradeBot
#include "stdafx.h"
#include "Tngcom.h"
#include "TradeBot.h"
#include "TraderInfo.h"

/////////////////////////////////////////////////////////////////////////////
// CTradeBot


STDMETHODIMP CTradeBot::get_ID(short *pVal)
{
	(*pVal) = _pBot->GetID();

	return S_OK;
}

STDMETHODIMP CTradeBot::get_Name(BSTR *pVal)
{
	CComBSTR		bstrName(_pBot->GetName());

	(*pVal) = bstrName.Copy();

	return S_OK;
}

STDMETHODIMP CTradeBot::get_Fitness(float *pVal)
{
	(*pVal) = _pBot->CalcFitness();

	return S_OK;
}

STDMETHODIMP CTradeBot::GetExpPayoff(ITradeBot *bot, float* pVal)
{
	void*			pBot;
	TraderInfo*		pInfo;
	HRESULT			hr;

	hr = bot->GetBot(&pBot);
	pInfo = _pBot->GetTraderInfo((tngTradeBot*)pBot);

	if (pInfo->numPayoffs > 0)
	{
		(*pVal) = pInfo->expPayoff;
	}
	else
	{
		(*pVal) = 0;
	}

	return S_OK;
}

STDMETHODIMP CTradeBot::GetBot(void **pVal)
{
	(*pVal) = _pBot;

	return S_OK;
}

STDMETHODIMP CTradeBot::get_Type(tngPOPULATION* pVal)
{
	if (_pBot->IsSeller())
	{
		if (_pBot->IsBuyer())
		{
			(*pVal) = tngBUYER_SELLER;
		}
		else
		{
			(*pVal) = tngPURE_SELLER;
		}
	}
	else
	{
		(*pVal) = tngPURE_BUYER;
	}

	return S_OK;
}

STDMETHODIMP CTradeBot::IsBuyer(BOOL *pVal)
{
	(*pVal) = _pBot->IsBuyer();

	return S_OK;
}

STDMETHODIMP CTradeBot::IsSeller(BOOL *pVal)
{
	(*pVal) = _pBot->IsSeller();

	return S_OK;
}

STDMETHODIMP CTradeBot::GetTraderInfo(ITradeBot *bot, ITraderInfo **pVal)
{
	void*						pBot;
	TraderInfo*					pInfo;
	ITraderInfo*				piInfo = 0;
	CComObject<CTraderInfo>*	poInfo = 0;
	HRESULT						hr;

	hr = bot->GetBot(&pBot);
	pInfo = _pBot->GetTraderInfo((tngTradeBot*)pBot);
	hr = CComObject<CTraderInfo>::CreateInstance(&poInfo);
	
	if(FAILED(hr))
	{
		return 0;
	}

	poInfo->Init(pInfo);

	piInfo = poInfo;
	piInfo->AddRef();
	(*pVal) = piInfo;

	return S_OK;
}
