// TradeBot.h : Declaration of the CTradeBot

#ifndef __TRADEBOT_H_
#define __TRADEBOT_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CTradeBot
class ATL_NO_VTABLE CTradeBot : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CTradeBot, &CLSID_TradeBot>,
	public IDispatchImpl<ITradeBot, &IID_ITradeBot, &LIBID_TNGCOMLib>
{
public:
	CTradeBot()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_TRADEBOT)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CTradeBot)
	COM_INTERFACE_ENTRY(ITradeBot)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// ITradeBot
public:
	STDMETHOD(GetTraderInfo)(/*[in]*/ ITradeBot* bot, /*[out, retval]*/ ITraderInfo** pVal);
	STDMETHOD(IsSeller)(/*[out, retval]*/ BOOL* pVal);
	STDMETHOD(IsBuyer)(/*[out, retval]*/ BOOL* pVal);
	STDMETHOD(get_Type)(/*[out, retval]*/ tngPOPULATION* pVal);
	STDMETHOD(GetBot)(/*[out, retval]*/ void** pVal);
	STDMETHOD(GetExpPayoff)(/*[in]*/ ITradeBot* bot, /*[out, retval]*/ float* pVal);
	STDMETHOD(get_Fitness)(/*[out, retval]*/ float *pVal);
	STDMETHOD(get_Name)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_ID)(/*[out, retval]*/ short *pVal);

	void				Init(tngTradeBot* pBot) { _pBot = pBot; }
protected:
	tngTradeBot*		_pBot;
};

#endif //__TRADEBOT_H_
