//
//  tngPop.h
//
//  Header file for tngPop.cpp
//  Last Revised: 7 November 1997
//

#ifndef TNGPOP_H
#define TNGPOP_H

#include "tng.h"      // TNG header files

///////////////////////////////////////////
//
//  class tngPopulation
//
//////////////////////////////////////////


class tngPopulation : public bioPopulation
{
public:
  void Init (void) {}       // Currently a null function

  override bioGType* GenGType (void);
    // Constructs and initializes a haploid (single strand) genotype.
    /*
    **   Pre: True
    **
    **  Post: (1) gtype points to a new bioHapGtype instance.
    **        (2) The bit count of *gtype, _bits, has been
    **            calculated as 8*tngTradeBot::FSMSize().
    **        (3) The byte string length of *gtype, _bytes, has
    **            been set to [(_bits-1)/8 + 1].
    **        (4) A character array of length _bytes has been
    **            newly constructed, and the member of *gtype,
    **            _dna, points to this array.
    **        (5) The array elements _dna[i] have been assigned
    **            random values by calls to rand().
    **        (6) The pointer gtype has been returned
    */

  override bioPType*  GenPType (bioGType* dna);  // Creates a tradebot.
    /*
    **   Pre: True
    **
    **  Post: (1) bot points to a new tngTradeBot instance.
    **        (2) dna has been supplied to the bot constructor.
    **        (3) The pointer bot has been returned.
    */
};

#endif // TNGPOP_H
