VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CNode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements Anim8.CNode

Public x As Double
Public y As Double
Public bot As TradeBot

Private m_vx As Double
Private m_vy As Double
Private m_fixed As Boolean

Const MAX_VEL = 5



Private Sub CNode_Draw(obj As Object, size As Integer)
    Dim pb As PictureBox
    Dim sym As String
    Dim col As Long
    
    Set pb = obj
    
    pb.DrawStyle = 0
    pb.FontSize = 18    ' larger font 8/9/2000
        
    Select Case bot.Type
        Case tngPURE_BUYER
            col = RGB(0, 255, 255) 'cyan
            sym = "B"
        Case tngPURE_SELLER
            col = RGB(255, 255, 0) ' yellow
            sym = "S"
        Case tngBUYER_SELLER
            col = RGB(0, 255, 0) ' green
            sym = "D"
    End Select
    
    If m_fixed Then
        col = RGB(255, 0, 0) ' red
    End If
    
    'pb.Circle (x, y), size + 2, col
    pb.CurrentX = x - size
    pb.CurrentY = y - size
    pb.ForeColor = col
    pb.Print sym
    pb.CurrentX = x ' + size
    pb.CurrentY = y
    pb.Print bot.ID + 1
End Sub

Private Property Let CNode_fixed(ByVal RHS As Boolean)
    m_fixed = RHS
End Property

Private Property Get CNode_fixed() As Boolean
    CNode_fixed = m_fixed
End Property

Public Sub CNode_Move(cof As Double)
    If m_fixed Then Exit Sub
    
    Select Case m_vx
        Case Is < -MAX_VEL
            x = x - MAX_VEL
        Case -MAX_VEL To MAX_VEL
            x = x + m_vx
        Case Is > -MAX_VEL
            x = x + MAX_VEL
    End Select
    
    Select Case m_vy
        Case Is < -MAX_VEL
            y = y - MAX_VEL
        Case -MAX_VEL To MAX_VEL
            y = y + m_vy
        Case Is > -MAX_VEL
            y = y + MAX_VEL
    End Select
    
    ' friction
    m_vx = m_vx * (1 - cof)
    m_vy = m_vy * (1 - cof)
End Sub

Private Sub CNode_Push(dx As Double, dy As Double)
    m_vx = m_vx + dx
    m_vy = m_vy + dy
End Sub

Private Property Let CNode_vx(ByVal RHS As Double)
    m_vx = RHS
End Property

Private Property Get CNode_vx() As Double
    CNode_vx = m_vx
End Property

Private Property Let CNode_vy(ByVal RHS As Double)
    m_vy = RHS
End Property

Private Property Get CNode_vy() As Double
    CNode_vy = m_vy
End Property

Private Property Let CNode_x(ByVal RHS As Double)
    x = RHS
End Property

Private Property Get CNode_x() As Double
    CNode_x = x
End Property

Private Property Let CNode_y(ByVal RHS As Double)
    y = RHS
End Property

Private Property Get CNode_y() As Double
    CNode_y = y
End Property

