// TraderInfo.h : Declaration of the CTraderInfo

#ifndef __TRADERINFO_H_
#define __TRADERINFO_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CTraderInfo
class ATL_NO_VTABLE CTraderInfo : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CTraderInfo, &CLSID_TraderInfo>,
	public IDispatchImpl<ITraderInfo, &IID_ITraderInfo, &LIBID_TNGCOMLib>
{
public:
	CTraderInfo()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_TRADERINFO)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CTraderInfo)
	COM_INTERFACE_ENTRY(ITraderInfo)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// ITraderInfo
public:
	STDMETHOD(get_TradingStreak)(/*[out, retval]*/ short *pVal);
	STDMETHOD(get_SumPayoffs)(/*[out, retval]*/ float *pVal);
	STDMETHOD(get_NumTrades)(/*[out, retval]*/ short *pVal);
	STDMETHOD(get_NumRefusals)(/*[out, retval]*/ short *pVal);
	STDMETHOD(get_NumPayoffs)(/*[out, retval]*/ short *pVal);
	STDMETHOD(get_LastPayoff)(/*[out, retval]*/ float *pVal);
	STDMETHOD(get_ExpPayoff)(/*[out, retval]*/ float *pVal);
	
	void				Init(TraderInfo* pInfo) { _pInfo = pInfo; }
protected:
	TraderInfo*		_pInfo;
};

#endif //__TRADERINFO_H_
