// Scores.h : Declaration of the CScores

#ifndef __SCORES_H_
#define __SCORES_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CScores
class ATL_NO_VTABLE CScores : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CScores, &CLSID_Scores>,
	public IDispatchImpl<IScores, &IID_IScores, &LIBID_TNGCOMLib>
{
public:
	CScores()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SCORES)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CScores)
	COM_INTERFACE_ENTRY(IScores)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IScores
public:
	STDMETHOD(get_StdDev)(/*[out, retval]*/ float *pVal);
	STDMETHOD(put_StdDev)(/*[in]*/ float newVal);
	STDMETHOD(get_Total)(/*[out, retval]*/ float *pVal);
	STDMETHOD(put_Total)(/*[in]*/ float newVal);
	STDMETHOD(get_Avg)(/*[out, retval]*/ float *pVal);
	STDMETHOD(put_Avg)(/*[in]*/ float newVal);
	STDMETHOD(get_Max)(/*[out, retval]*/ float *pVal);
	STDMETHOD(put_Max)(/*[in]*/ float newVal);
	STDMETHOD(get_Min)(/*[out, retval]*/ float *pVal);
	STDMETHOD(put_Min)(/*[in]*/ float newVal);

protected:
	float		_min;
	float		_max;
	float		_avg;
	float		_total;
	float		_stddev;
};

#endif //__SCORES_H_
