// tngcom.idl : IDL source for tngcom.dll
//

// This file will be processed by the MIDL tool to
// produce the type library (tngcom.tlb) and marshalling code.

import "oaidl.idl";
import "ocidl.idl";

typedef enum
{
	tngALL,
	tngPURE_BUYER,
	tngPURE_SELLER,
	tngBUYER_SELLER
} tngPOPULATION;

typedef enum
{
	tngBOTH_COOP,
	tngBOTH_DEFECT,
	tngTEMPTATION,
	tngSUCKER,
	tngINIT_EXP,
	tngINACTIVE,
	tngREFUSAL
} tngPAYOFF;

interface ISimulation;
interface IScores;
interface IPopulation;
interface ITradeBot;
interface ITraderInfo;

	[
		object,
		uuid(1CDEBBAD-1055-11D3-8375-00104B73BFA9),
		dual,
		helpstring("ISimulation Interface"),
		pointer_default(unique)
	]
	interface ISimulation : IDispatch
	{
		[propget, id(1), helpstring("property GMax")] HRESULT GMax([out, retval] short *pVal);
		[propput, id(1), helpstring("property GMax")] HRESULT GMax([in] short newVal);
		[propget, id(2), helpstring("property IMax")] HRESULT IMax([out, retval] short *pVal);
		[propput, id(2), helpstring("property IMax")] HRESULT IMax([in] short newVal);
		[propget, id(3), helpstring("property RandomSeed")] HRESULT RandomSeed([out, retval] short *pVal);
		[propput, id(3), helpstring("property RandomSeed")] HRESULT RandomSeed([in] short newVal);
		[propget, id(4), helpstring("property MutationRate")] HRESULT MutationRate([out, retval] float *pVal);
		[propput, id(4), helpstring("property MutationRate")] HRESULT MutationRate([in] float newVal);
		[propget, id(5), helpstring("property FsmStates")] HRESULT FsmStates([out, retval] short *pVal);
		[propput, id(5), helpstring("property FsmStates")] HRESULT FsmStates([in] short newVal);
		[propget, id(6), helpstring("property FsmMemory")] HRESULT FsmMemory([out, retval] short *pVal);
		[propput, id(6), helpstring("property FsmMemory")] HRESULT FsmMemory([in] short newVal);
		[id(7), helpstring("method Run")] HRESULT Run();
		[id(8), helpstring("method Go")] HRESULT Go();
		[id(9), helpstring("method GetScores")] HRESULT GetScores([in] tngPOPULATION, [out, retval] IScores**);
		[id(10), helpstring("method GetPopulation")] HRESULT GetPopulation([in] tngPOPULATION ePop, [out, retval] IPopulation**);
		[propget, id(11), helpstring("property PureBuyerCount")] HRESULT PureBuyerCount([out, retval] short *pVal);
		[propput, id(11), helpstring("property PureBuyerCount")] HRESULT PureBuyerCount([in] short newVal);
		[propget, id(12), helpstring("property PureSellerCount")] HRESULT PureSellerCount([out, retval] short *pVal);
		[propput, id(12), helpstring("property PureSellerCount")] HRESULT PureSellerCount([in] short newVal);
		[propget, id(13), helpstring("property BuysellCount")] HRESULT BuysellCount([out, retval] short *pVal);
		[propput, id(13), helpstring("property BuysellCount")] HRESULT BuysellCount([in] short newVal);
		[propget, id(14), helpstring("property Payoff")] HRESULT Payoff(tngPAYOFF ePayoff, [out, retval] float *pVal);
		[propput, id(14), helpstring("property Payoff")] HRESULT Payoff(tngPAYOFF ePayoff, [in] float newVal);
		[propget, id(15), helpstring("property ElitePercent")] HRESULT ElitePercent(tngPOPULATION ePop, [out, retval] float *pVal);
		[propput, id(15), helpstring("property ElitePercent")] HRESULT ElitePercent(tngPOPULATION ePop, [in] float newVal);
		[propget, id(16), helpstring("property BuyerQuota")] HRESULT BuyerQuota([out, retval] short *pVal);
		[propput, id(16), helpstring("property BuyerQuota")] HRESULT BuyerQuota([in] short newVal);
		[propget, id(17), helpstring("property SellerQuota")] HRESULT SellerQuota([out, retval] short *pVal);
		[propput, id(17), helpstring("property SellerQuota")] HRESULT SellerQuota([in] short newVal);
		[id(18), helpstring("method Pause")] HRESULT Pause();
		[id(19), helpstring("method Resume")] HRESULT Resume();
		[id(20), helpstring("method Stop")] HRESULT Stop();
		[id(21), helpstring("method OpenFile")] HRESULT OpenFile([in] BSTR inifile);
		[id(22), helpstring("method SaveFile")] HRESULT SaveFile([in] BSTR inifile);
		[propget, id(23), helpstring("property PrintIt")] HRESULT PrintIt([out, retval] short *pVal);
		[propput, id(23), helpstring("property PrintIt")] HRESULT PrintIt([in] short newVal);
		[propget, id(24), helpstring("property PrintGen")] HRESULT PrintGen([out, retval] short *pVal);
		[propput, id(24), helpstring("property PrintGen")] HRESULT PrintGen([in] short newVal);
		[propget, id(25), helpstring("property ExperienceGain")] HRESULT ExperienceGain([out, retval] float *pVal);
		[propput, id(25), helpstring("property ExperienceGain")] HRESULT ExperienceGain([in] float newVal);
	};
[
	uuid(1CDEBBA1-1055-11D3-8375-00104B73BFA9),
	version(1.0),
	helpstring("tngcom 1.0 Type Library")
]
library TNGCOMLib
{
	importlib("stdole32.tlb");
	importlib("stdole2.tlb");

	[
		uuid(9AE14F63-1058-11D3-8375-00104B73BFA9),
		helpstring("_ISimulationEvents Interface")
	]
	dispinterface _ISimulationEvents
	{
		properties:
		methods:
		[id(1), helpstring("method GenerationBegin")] HRESULT GenerationBegin(short gen);
		[id(2), helpstring("method GenerationEnd")] HRESULT GenerationEnd(short gen);
		[id(3), helpstring("method TradeCycleBegin")] HRESULT TradeCycleBegin(short cycle);
		[id(4), helpstring("method TradeCycleEnd")] HRESULT TradeCycleEnd(short cycle);
		[id(5), helpstring("method SimRunning")] HRESULT SimRunning();
		[id(6), helpstring("method SimPaused")] HRESULT SimPaused();
		[id(7), helpstring("method SimResumed")] HRESULT SimResumed();
		[id(8), helpstring("method SimStopped")] HRESULT SimStopped();
		[id(9), helpstring("method SimFinished")] HRESULT SimFinished();
	};
	[
		object,
		uuid(6DCA38C1-1468-11D3-8375-00104B73BFA9),
		dual,
		helpstring("IScores Interface"),
		pointer_default(unique)
	]
	interface IScores : IDispatch
	{
		[propget, id(1), helpstring("property Min")] HRESULT Min([out, retval] float *pVal);
		[propput, id(1), helpstring("property Min")] HRESULT Min([in] float newVal);
		[propget, id(2), helpstring("property Max")] HRESULT Max([out, retval] float *pVal);
		[propput, id(2), helpstring("property Max")] HRESULT Max([in] float newVal);
		[propget, id(3), helpstring("property Avg")] HRESULT Avg([out, retval] float *pVal);
		[propput, id(3), helpstring("property Avg")] HRESULT Avg([in] float newVal);
		[propget, id(4), helpstring("property Total")] HRESULT Total([out, retval] float *pVal);
		[propput, id(4), helpstring("property Total")] HRESULT Total([in] float newVal);
		[propget, id(5), helpstring("property StdDev")] HRESULT StdDev([out, retval] float *pVal);
		[propput, id(5), helpstring("property StdDev")] HRESULT StdDev([in] float newVal);
	};
	[
		object,
		uuid(37B855A1-1864-11D3-8375-00104B73BFA9),
		dual,
		helpstring("IPopulation Interface"),
		pointer_default(unique)
	]
	interface IPopulation : IDispatch
	{
		[propget, id(1), helpstring("property Size")] HRESULT Size([out, retval] short *pVal);
		[propget, id(2), helpstring("property Elite")] HRESULT Elite([out, retval] short *pVal);
		[propget, id(3), helpstring("property MutationRate")] HRESULT MutationRate([out, retval] double *pVal);
		[id(4), helpstring("method GetTradeBot")] HRESULT GetTradeBot([in] short idx, [out, retval] ITradeBot**);
	};
	[
		object,
		uuid(4DB16A81-1DE7-11D3-8375-00104B73BFA9),
		dual,
		helpstring("ITradeBot Interface"),
		pointer_default(unique)
	]
	interface ITradeBot : IDispatch
	{
		[propget, id(1), helpstring("property ID")] HRESULT ID([out, retval] short *pVal);
		[propget, id(2), helpstring("property Name")] HRESULT Name([out, retval] BSTR *pVal);
		[propget, id(3), helpstring("property Fitness")] HRESULT Fitness([out, retval] float *pVal);
		[id(4), helpstring("method GetExpPayoff")] HRESULT GetExpPayoff([in] ITradeBot* bot, [out, retval] float* pVal);
		[id(5), helpstring("method GetBot")] HRESULT GetBot([out, retval] void** pVal);
		[propget, id(6), helpstring("property Type")] HRESULT Type([out, retval] tngPOPULATION *pVal);
		[id(7), helpstring("method IsBuyer")] HRESULT IsBuyer([out, retval] BOOL* pVal);
		[id(8), helpstring("method IsSeller")] HRESULT IsSeller([out, retval] BOOL* pVal);
		[id(9), helpstring("method GetTraderInfo")] HRESULT GetTraderInfo([in] ITradeBot* bot, [out, retval] ITraderInfo** pVal);
	};
	[
		object,
		uuid(1A3F5801-3067-11D3-8375-00104B73BFA9),
		dual,
		helpstring("ITraderInfo Interface"),
		pointer_default(unique)
	]
	interface ITraderInfo : IDispatch
	{
		[propget, id(1), helpstring("property ExpPayoff")] HRESULT ExpPayoff([out, retval] float *pVal);
		[propget, id(2), helpstring("property LastPayoff")] HRESULT LastPayoff([out, retval] float *pVal);
		[propget, id(3), helpstring("property NumPayoffs")] HRESULT NumPayoffs([out, retval] short *pVal);
		[propget, id(4), helpstring("property NumRefusals")] HRESULT NumRefusals([out, retval] short *pVal);
		[propget, id(5), helpstring("property NumTrades")] HRESULT NumTrades([out, retval] short *pVal);
		[propget, id(6), helpstring("property SumPayoffs")] HRESULT SumPayoffs([out, retval] float *pVal);
		[propget, id(7), helpstring("property TradingStreak")] HRESULT TradingStreak([out, retval] short *pVal);
	};

	[
		uuid(1CDEBBAE-1055-11D3-8375-00104B73BFA9),
		helpstring("Simulation Class")
	]
	coclass Simulation
	{
		[default] interface ISimulation;
		[default, source] dispinterface _ISimulationEvents;
	};
	[
		uuid(6DCA38C2-1468-11D3-8375-00104B73BFA9),
		helpstring("Scores Class")
	]
	coclass Scores
	{
		[default] interface IScores;
	};
	[
		uuid(37B855A2-1864-11D3-8375-00104B73BFA9),
		helpstring("Population Class")
	]
	coclass Population
	{
		[default] interface IPopulation;
	};
	[
		uuid(4DB16A82-1DE7-11D3-8375-00104B73BFA9),
		helpstring("TradeBot Class")
	]
	coclass TradeBot
	{
		[default] interface ITradeBot;
	};
	[
		uuid(1A3F5802-3067-11D3-8375-00104B73BFA9),
		helpstring("TraderInfo Class")
	]
	coclass TraderInfo
	{
		[default] interface ITraderInfo;
	};
};
