//
// tng.ini (for tnglab.101)
//
// Configuration file for the basic TNG parameters
// Last revised: 9 August 2000 ("WallflowerPayoff" changed to "InactivePayoff")
//
// Constraints on the user-supplied parameter values in tng.ini:
//
// GMax and IMax can be any positive integers.  PrintGen can be any
// nonnegative integer not exceeding GMax.  PrintIt can be any
// nonnegative integer not exceeding IMax.  RandomSeed can be any
// unsigned integer.  MutationRate can be any nonnegative number
// less than 1.  FsmStates can be any positive integer, FsmMemory
// can be any positive integer not exceeding 32, and TraderCount
// can be any integer greater than 1. [Caution: Hardware-specific
// memory limitations may further restrict FsmStates, FsmMemory,
// and TraderCount in practice].
//      PureBuyerCount, PureSellerCount, and BuySellCount can
// be any nonnegative integers that exactly add up to TraderCount.
// The percentages ElitePercentPB, ElitePercentPS, and ElitePercentBS
// for elite pure buyers, elite pure sellers, and elite buyer-sellers
// can be any real numbers from zero to one inclusive.  BuyerQuota can
// be any nonnegative integer not exceeding SellerCount, and SellerQuota
// can be any nonnegative integer.  Finally, InitExpPayoff, Temptation,
// BothCoop, BothDefect, Sucker, RefusalPayoff, and InactivePayoff
// can be any real numbers.
//

[tng]

GMax = 5
IMax = 150
PrintGen = 3
PrintIt = 3
RandomSeed = 41
MutationRate = 0.005
FsmStates = 16
FsmMemory = 1
TraderCount = 24
PureBuyerCount = 0
PureSellerCount = 0
BuySellCount = 24
ElitePercentPB = 0.67
ElitePercentPS = 0.67
ElitePercentBS = 0.67
BuyerQuota = 1
SellerQuota = 2
InitExpPayoff = +1.4
Temptation = +3.4
BothCoop = +1.4
BothDefect = -0.6
Sucker = -1.6
RefusalPayoff = -0.5
InactivePayoff = +0.0
